'use strict';

var _utils = require('./utils');

var _atomStore = require('atom-store');

var _atomStore2 = _interopRequireDefault(_atomStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 *  Copyright (c) 2014-2015, Facebook, Inc.
 *  All rights reserved.
 *
 *  This source code is licensed under the BSD-style license found in the
 *  LICENSE file in the root directory of this source tree. An additional grant
 *  of patent rights can be found in the PATENTS file in the same directory.
 */

function cursorFrom(data, keyPath, onChange) {
  var atom = (0, _atomStore2.default)(data);
  if (arguments.length === 1) {
    keyPath = [];
  } else if (typeof keyPath === 'function') {
    onChange = keyPath;
    keyPath = [];
  } else {
    keyPath = (0, _utils.valToKeyPath)(keyPath);
  }

  if (typeof onChange !== 'undefined') {
    atom.watch(onChange);
  }

  return (0, _utils.makeCursor)(data, keyPath, atom.write.bind(atom), atom.read);
}

exports.from = cursorFrom;